org.apache.pdfbox.pdmodel.font

## Class PDCIDFontType2

- java.lang.Object
- - org.apache.pdfbox.pdmodel.font.PDCIDFont
  - - org.apache.pdfbox.pdmodel.font.PDCIDFontType2

All Implemented Interfaces:
  COSObjectable, PDFontLike, PDVectorFont

    public class PDCIDFontType2
    extends PDCIDFont

Type 2 CIDFont (TrueType).

Author:
  Ben Litchfield

### Field Summary

### Fields inherited from class org.apache.pdfbox.pdmodel.font.PDCIDFont

`dict, parent`

### Constructor Summary

Constructors
Constructor and Description
`PDCIDFontType2(COSDictionary fontDictionary, PDType0Font parent)` Constructor.
`PDCIDFontType2(COSDictionary fontDictionary, PDType0Font parent, org.apache.fontbox.ttf.TrueTypeFont trueTypeFont)` Constructor.

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `codeToCID(int code)` Returns the CID for the given character code.
`int` `codeToGID(int code)` Returns the GID for the given character code.
`byte[]` `encode(int unicode)` Encodes the given Unicode code point for use in a PDF content stream.
`org.apache.fontbox.util.BoundingBox` `getBoundingBox()` Returns the font's bounding box.
`Matrix` `getFontMatrix()` Returns the font matrix, which represents the transformation from glyph space to text space.
`float` `getHeight(int code)` Returns the height of the given character, in glyph space.
`GeneralPath` `getPath(int code)` Returns the glyph path for the given character code in a PDF.
`org.apache.fontbox.ttf.TrueTypeFont` `getTrueTypeFont()` Returns the embedded or substituted TrueType font.
`float` `getWidthFromFont(int code)` Returns the width of a glyph in the embedded font file.
`boolean` `hasGlyph(int code)` Returns true if this font contains a glyph for the given character code in a PDF.
`boolean` `isDamaged()` Returns true if the embedded font file is damaged.
`boolean` `isEmbedded()` Returns true if the font file is embedded in the PDF.

### Methods inherited from class org.apache.pdfbox.pdmodel.font.PDCIDFont

`getAverageFontWidth, getBaseFont, getCIDSystemInfo, getCOSObject, getFontDescriptor, getName, getParent, getPositionVector, getVerticalDisplacementVectorY, getWidth, hasExplicitWidth`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### PDCIDFontType2

    public PDCIDFontType2(COSDictionary fontDictionary,
                          PDType0Font parent)
                   throws IOException

Constructor.

Parameters:
  `fontDictionary` - The font dictionary according to the PDF specification.
  `parent` - The parent font.
Throws:
  `IOException`

#### PDCIDFontType2

    public PDCIDFontType2(COSDictionary fontDictionary,
                          PDType0Font parent,
                          org.apache.fontbox.ttf.TrueTypeFont trueTypeFont)
                   throws IOException

Constructor.

Parameters:
  `fontDictionary` - The font dictionary according to the PDF specification.
  `parent` - The parent font.
  `trueTypeFont` - The true type font used to create the parent font
Throws:
  `IOException`

### Method Detail

#### getFontMatrix

    public Matrix getFontMatrix()

Description copied from interface: `PDFontLike`
Returns the font matrix, which represents the transformation from glyph space to text space.

#### getBoundingBox

    public org.apache.fontbox.util.BoundingBox getBoundingBox()
                                                       throws IOException

Description copied from interface: `PDFontLike`
Returns the font's bounding box.

Throws:
  `IOException`

#### codeToCID

    public int codeToCID(int code)

Description copied from class: `PDCIDFont`
Returns the CID for the given character code. If not found then CID 0 is returned.

Specified by:
  `codeToCID` in class `PDCIDFont`
Parameters:
  `code` - character code
Returns:
  CID

#### codeToGID

    public int codeToGID(int code)
                  throws IOException

Returns the GID for the given character code.

Specified by:
  `codeToGID` in class `PDCIDFont`
Parameters:
  `code` - character code
Returns:
  GID
Throws:
  `IOException`

#### getHeight

    public float getHeight(int code)
                    throws IOException

Description copied from interface: `PDFontLike`
Returns the height of the given character, in glyph space. This can be expensive to calculate. Results are only approximate.

Warning: This method is deprecated in PDFBox 2.0 because there is no meaningful value which it can return. The `PDFontLike.getWidth(int)` method returns the advance width of a glyph, but there is no corresponding advance height. The logical height of a character is the same for every character in a font, so if you want that, retrieve the font bbox's height. Otherwise if you want the visual bounds of the glyph then call getPath(..) on the appropriate PDFont subclass to retrieve the glyph outline as a GeneralPath. See the cyan rectangles in the DrawPrintTextLocations.java example to see this in action.

Parameters:
  `code` - character code
Throws:
  `IOException`

#### getWidthFromFont

    public float getWidthFromFont(int code)
                           throws IOException

Description copied from interface: `PDFontLike`
Returns the width of a glyph in the embedded font file.

Parameters:
  `code` - character code
Returns:
  width in glyph space
Throws:
  `IOException` - if the font could not be read

#### encode

    public byte[] encode(int unicode)

Description copied from class: `PDCIDFont`
Encodes the given Unicode code point for use in a PDF content stream. Content streams use a multi-byte encoding with 1 to 4 bytes.

This method is called when embedding text in PDFs and when filling in fields.

Specified by:
  `encode` in class `PDCIDFont`
Parameters:
  `unicode` - Unicode code point.
Returns:
  Array of 1 to 4 PDF content stream bytes.

#### isEmbedded

    public boolean isEmbedded()

Description copied from interface: `PDFontLike`
Returns true if the font file is embedded in the PDF.

#### isDamaged

    public boolean isDamaged()

Description copied from interface: `PDFontLike`
Returns true if the embedded font file is damaged.

#### getTrueTypeFont

    public org.apache.fontbox.ttf.TrueTypeFont getTrueTypeFont()

Returns the embedded or substituted TrueType font. May be an OpenType font if the font is not embedded.

#### getPath

    public GeneralPath getPath(int code)
                        throws IOException

Description copied from interface: `PDVectorFont`
Returns the glyph path for the given character code in a PDF.

Parameters:
  `code` - character code in a PDF. Not to be confused with unicode.
Throws:
  `IOException` - if the font could not be read

#### hasGlyph

    public boolean hasGlyph(int code)
                     throws IOException

Description copied from interface: `PDVectorFont`
Returns true if this font contains a glyph for the given character code in a PDF.

Parameters:
  `code` - character code in a PDF. Not to be confused with unicode.
Throws:
  `IOException`